import urllib
from BeautifulSoup import BeautifulSoup
import re
import cPickle

def scrape_times(url,n,timelist):
    f = urllib.urlopen(url)
    s = f.read()
    print " read: ", len(s), " bytes"
    f.close()
    soup = BeautifulSoup(s) 
    table = soup.find("table")
    #n = 1
    for row in table.findAll('tr'):
        col = row.findAll('td')
        rank=col[0].string # first column should have rank of runner
        p2case=0

        # equal times give funny rankings, thus the +/- allowance here
        
        ok_ranks = [str(n), str(n-1), str(n+1), str(n-2), str(n+2), str(n-3), str(n+3), str(n-4), str(n+4)]
        if rank in ok_ranks:
        #if rank==str(n) or rank==str(n-1) or rank==str(n+1) or rank==str(n-2) or rank==str(n+2) or rank==str(n-3) or rank==str(n+3) or rank==str(n-4) or rank==str(n+4):
            #print row
            r = int(rank)
            
            nr = col[1].string # runners number
            n1 = col[2].string # last name
            n2 = col[3].string # first name
            cl = col[4].string # club
            sar = col[5].string # series
            t1 = col[6].string # gun-time
            t2 = col[7].string # chip time
            #print r, " ", nr," n=",n1," n2=",n2," cl=",cl," sar=",sar,
            # print "t1=",t1," t2=",t2
            timepat = re.compile(r'^(\d{1}):(\d{2}):(\d{2})')
            t2s = timepat.search(t1).groups()
            # convert to minutes
            mins = float(t2s[0])*60 + float(t2s[1]) + float(t2s[2])/float(60)
            #print n,": h=",t2s[0], " m=",t2s[1]," s=",t2s[2]," mins=",mins
            #item=[]
            #item.append(mins)
            #item.append(cl)
            #timelist.append(item)
            timelist.append(mins) # append only the minutes to the list which is saved.
            n = n+1
        #else:
        #    print "could not parse: "
        #    print row
    #print " scrape n= ", n
    #raw_input("Press Enter to continue") 
    return n-1

def printtime(mins):
    h = float(mins)/float(60)
    hint = int(h)
    m = (h-hint)*60
    mint = int(m)
    s = (m-mint)*60
    sint = s
    print hint,":",mint,":",sint 
    
if __name__ == "__main__":  
    url_list = []

    
    # HCM 2010 settings:
    # beg_first = "http://www.marathon.fi/ilmo2/results_show.php?serie="
    # serie =      ["HCM_0_100", "HCM_M_18", "HCM_M_40", "HCM_M_45", "HCM_M_50", "HCM_M_55", "HCM_M_60",     
    #                "HCM_M_65", "HCM_M_70", "HCM_N_18", "HCM_N_35", "HCM_N_40", "HCM_N_45", "HCM_N_50",
    #               "HCM_N_55", "HCM_N_60"]
    # Nmax_serie = [5000,         1800,          500,      400,         300 ,         200  ,    100    ,
    #    0      ,    0,  500,   100,  200, 100 , 100 , 0, 0 ]
    # end_first = "&hcmyear=2010&hcmid=1&base=results_hcm2008"

    # format for HCR 2011 results website:
    # http://www.marathontulokset.com/ilmo2/results_show.php?serie=HCR_0_130&hcmyear=2011&hcmid=2&base=results_hcr2008    
    beg_first = "http://www.marathontulokset.com/ilmo2/results_show.php?serie="
    serie =      ["HCR_0_130", "HCR_M_16","HCR_N_16","HCR_M_40","HCR_M_50","HCR_M_60","HCR_N_35","HCR_N_45","HCR_N_55"]
    Nmax_serie = [10470, 3944, 2783,1280,591,176,931,598,164]
    end_first = "&hcmyear=2011&hcmid=2&base=results_hcr2008"
     
    # select what we want to scrape:
    n_serie = 8

    first_url = beg_first + serie[n_serie] + end_first
    
    url_list.append( first_url )
    # hcr 2011 format for second page onwards:
    # http://www.marathontulokset.com/ilmo2/results_show.php?lang=fi&rangestart=100&nro=&fname=&lname=&teamname=&serie=HCR_0_130&timeselect=1&hcmyear=2011&hcmid=2
    begin_url= "http://www.marathontulokset.com/ilmo2/results_show.php?lang=fi&rangestart=" # 100
    mid_url = "&nro=&fname=&lname=&teamname=&serie="
    end_url = "&timeselect=1&hcmyear=2011&hcmid=2"    
    Nmax=Nmax_serie[n_serie]
    n=100
    while (n<=Nmax):
        url = begin_url + str(n) + mid_url + serie[n_serie] + end_url
        n=n+100
        url_list.append( url )
        
    timelist=[]
    n=1
    for myurl in url_list:
        print "scraping: ", myurl
        found = scrape_times(myurl,n,timelist)
        if found != n:
            print "error scraping URL", myurl
            print "found= ",found," n=",n
        n=n+100
    print " got ",len(timelist)," times"
    #printtime(timelist[198])
    print " writing file: ",  serie[n_serie]
    cPickle.dump(timelist, open( serie[n_serie] , 'wb')) 
